/**
 * jQuery-multiAutocomplete
 * @version: v1.1.1
 * @author: Israel Moraes
 * 
 * Created by Israel Moraes on 2020-07-13. Please report any bug at https://github.com/IsraelFM/jQuery-multiAutocomplete
 *
 * Developed with UMD (Universal Module Definition) patterns for JavaScript modules that work everywhere.
 * https://github.com/umdjs/umd/blob/master/templates/jqueryPlugin.js
 */

!function(e){"function"==typeof define&&define.amd?define(["jquery"],e):"object"==typeof exports&&"function"==typeof require?module.exports=e(require("jquery")):e(jQuery)}(function(e){"use strict";const t={ALT:18,LEFT:37,UP:38,RIGHT:39,DOWN:40,DEL:46,TAB:9,RETURN:13,ESC:27,COMMA:188,PAGEUP:33,PAGEDOWN:34,BACKSPACE:8,SPACE:32},s={createContainer:function(e,t){let s=19.1*t,n=document.createElement("div");return n.className=e,n.style.position="absolute",n.style.display="none",n.style["max-height"]=s+"px",n.style["overflow-y"]="auto",n}};e.fn.multiAutocomplete=function(o,i){i=i||{},n=e.jPluginDefaults;return e(this).each(function(){let n=e(this).data("multiAutocomplete");if("string"!=typeof o)return n&&n.destroy(),e(this).data("multiAutocomplete",new function(n,o,i){let l={events:function(){n.on("keydown.multiAutocomplete",function(s){if(s.keyCode===t.SPACE&&(s.metaKey||s.ctrlKey?l.createSuggestionContainers():u.hide()),s.keyCode===t.UP||s.keyCode===t.DOWN)return!1;if(-1!==e.inArray(s.keyCode,a.options.stopSuggestionKeys)){if(u.children().length>0){let e=u.find(`.${a.class.suggestion}.${a.class.selected}`).html();l.updateSelection(l.getCompletion(e))}return n.blur(),n.focus(),!1}}).on("keyup.multiAutocomplete",function(e){let s,n=e.altKey||e.metaKey||e.ctrlKey,o=a.class.suggestion,i=a.class.selected;switch(e.keyCode){case t.LEFT:case t.RIGHT:case t.TAB:case t.BACKSPACE:case t.DEL:(u.is(":visible")||a.options.autosuggest)&&l.createSuggestionContainers();break;case t.ESC:u.hide();break;case t.UP:a.selectedIndex>0&&(s=u.find(`.${o}:not(:first-child).${i}`).removeClass(i).prev().addClass(i),a.selectedIndex=s.data("index"),s.get(0).scrollIntoView({block:"nearest"}));break;case t.DOWN:a.selectedIndex<u.children().length-1&&(s=u.find(`.${o}:not(:last-child).${i}`).removeClass(i).next().addClass(i),a.selectedIndex=s.data("index"),s.get(0).scrollIntoView({block:"nearest"}));break;default:(u.is(":visible")||!n&&a.options.autosuggest)&&l.getChunk().length>=a.options.minChunkSize&&l.createSuggestionContainers()}}).on("blur.multiAutocomplete",function(){u.hide()}),u.on("mouseout.multiAutocomplete",function(){e("."+a.class.suggestion).removeClass(a.class.hover)}).on("mouseover.multiAutocomplete","."+a.class.suggestion,function(){e(this).addClass(a.class.hover)}).on("mousedown.multiAutocomplete","."+a.class.suggestion,function(t){let s=e(this).html();l.updateSelection(l.getCompletion(s)),l.createSuggestionContainers(),n.focus(),t.preventDefault()})},destroyEvents:function(){n.off(["keydown","keyup","blur","mouseout","mouseover","mousedown",""].join(".multiAutocomplete "))},getChunk:function(){let e,t,s=a.options.delimiters.split(""),o=n.val().substr(0,l.getInputSelection(n).start),i=-1;for(let n=0;n<s.length;n++)e=s[n],(t=o.lastIndexOf(e))>i&&(i=t);return i<0?o:o.substr(i+1)},updateSelection:function(e){let t=l.getInputSelection(n),s=t.start,o=s+e.length;if(t.elDOM.setRangeText)t.elDOM.setRangeText(e);else{let t=n.val().substring(0,s),i=n.val().substring(o,n.val().length),l=n.val().substring(s,o);n.val(t+e+l+i)}t.elDOM.setSelectionRange(o,o)},createSuggestionContainers:function(){let e,t=l.getChunk(),s="",n=0;if(a.options.prefixRegexps.test(t))for(let i=0;i<o.length;i++)e=o[i],a.options.ignoreCase&&(e=e.toLowerCase(),t=t.toLowerCase()),0===e.indexOf(t)&&(s+=`<div class="${`${a.class.suggestion} ${0===n?a.class.selected:""}`}" data-index="${n++}">${`<strong>${t}</strong>${e.substr(t.length)}`}</div>`);u.html(s),s?u.show():u.hide(),a.selectedIndex=0},getCompletion:function(e){let t=l.getChunk();return(t+e.replace(/<[^>]*>(.*?)[^>]*>/,"")).substr(t.length)+a.options.endingSymbols},getInputSelection:function(e){let t=0,s=0;return"number"==typeof(e=e.get(0)).selectionStart&&"number"==typeof e.selectionEnd&&(t=e.selectionStart,s=e.selectionEnd),{elDOM:e,start:t,end:s}}};n=e(n);let u,a=this;a.suggestions=o,a.options=i,a.destroy=function(e){l.destroyEvents(),e.removeData("multiAutocomplete")},a.init=function(t){if(t){a.options=e.extend({},e.jPluginDefaults,i),a.selectedIndex=-1,a.class={suggestions:"multiAutocomplete-suggestions",suggestion:"multiAutocomplete-suggestion",selected:"multiAutocomplete-selected",hover:"multiAutocomplete-hover"},n.attr("autocomplete","off");let t=s.createContainer(a.class.suggestions,a.options.maxShowSuggestion);u=n.after(t).next(),l.destroyEvents(),l.events()}},a.init(n.is("input"))}(this,o,i));n&&"function"==typeof n[o]&&n[o](e(this))}),this};let n={delimiters:" ",minChunkSize:1,autosuggest:!0,endingSymbols:"",prefixRegexps:/.*/,stopSuggestionKeys:[9,13],ignoreCase:!1,maxShowSuggestion:10};e.jPluginDefaults=e.jPluginDefaults||{},n=e.jPluginDefaults=e.extend(!0,{},n,e.jPluginDefaults)});